#region Copyright Syncfusion Inc. 2001-2019.
// Copyright Syncfusion Inc. 2001-2019. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion
using Filtering;
using Syncfusion.WinForms.Controls;
using Syncfusion.WinForms.DataGrid;
using System;
using System.Collections;
using System.Linq;
using System.Windows.Forms;
using System.Collections.ObjectModel;
using Syncfusion.WinForms.DataPager;
using System.Data;
using System.Data.SqlClient;
using Syncfusion.WinForms.DataGrid.GridFiltering;


namespace Filtering
{
    /// <summary>
    /// Summary description for Form1.
    /// </summary>
    public partial class Form1 : Form
    {

        #region Constructor

        /// <summary>
        /// Initializes the new instance for the Form.
        /// </summary>
        public Form1()
        {
            InitializeComponent();


            this.sfDataGrid1.DataSource = new OrderInfoCollection().OrdersListDetails;
            this.sfDataGrid1.AllowFiltering = true;

            this.sfDataGrid1.Columns["OrderDate"].Format = "MM/dd/yyyy";
          
            this.sfDataGrid1.FilterPopupShowing += sfDataGrid1_FilterPopupShowing;
        }

        void sfDataGrid1_FilterPopupShowing(object sender, Syncfusion.WinForms.DataGrid.Events.FilterPopupShowingEventArgs e)
        {
            var customFilterControl = new CustomFilterControl();
            customFilterControl.Column = e.Column;
            if (!(e.Control is CustomFilterControl))
            {
                e.Cancel = true;
                customFilterControl.Show(this.sfDataGrid1.TableControl, e.Location);
            }
        } 

  
        #endregion
    }

    public class CustomFilterControl : DataGridFilterControl
    {
        bool itemDrawingWired = false;

        protected override void SetCheckedListBox(Control control, System.Drawing.Point location, System.Drawing.Size size)
        {
            base.SetCheckedListBox(control, location, size);

            if(this.CheckListBox != null && !itemDrawingWired)
            {                
                this.CheckListBox.DrawItem += CheckListBox_DrawItem;
                itemDrawingWired = true;
            }
        }

        void CheckListBox_DrawItem(object sender, Syncfusion.WinForms.ListView.Events.DrawItemEventArgs e)
        {
            if (e.ItemType == Syncfusion.WinForms.ListView.Enums.ItemType.SelectAllItem)
                return;

            if (this.Column is GridDateTimeColumn)
            {
                DateTime date;
                if (DateTime.TryParse(e.Text, out date))
                    e.Text = date.ToString("MM/dd/yyyy");
            }
        }
    }
}
